org.apache.activemq.artemis.api.core.management

## Interface ActiveMQServerControl

-     public interface ActiveMQServerControl

  An ActiveMQServerControl is used to manage ActiveMQ Artemis servers.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `ADDRESS_MEMORY_USAGE_DESCRIPTION`
    `static String` | `CONNECTION_COUNT_DESCRIPTION`
    `static String` | `DISK_STORE_USAGE_DESCRIPTION`
    `static String` | `TOTAL_CONNECTION_COUNT_DESCRIPTION`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addAddressSettings(String addressMatch, String DLA, String expiryAddress, long expiryDelay, boolean lastValueQueue, int deliveryAttempts, long maxSizeBytes, int pageSizeBytes, int pageMaxCacheSize, long redeliveryDelay, double redeliveryMultiplier, long maxRedeliveryDelay, long redistributionDelay, boolean sendToDLAOnNoRoute, String addressFullMessagePolicy, long slowConsumerThreshold, long slowConsumerCheckPeriod, String slowConsumerPolicy, boolean autoCreateJmsQueues, boolean autoDeleteJmsQueues, boolean autoCreateJmsTopics, boolean autoDeleteJmsTopics)` adds a new address setting for a specific address
    `void` | `addAddressSettings(String addressMatch, String DLA, String expiryAddress, long expiryDelay, boolean lastValueQueue, int deliveryAttempts, long maxSizeBytes, int pageSizeBytes, int pageMaxCacheSize, long redeliveryDelay, double redeliveryMultiplier, long maxRedeliveryDelay, long redistributionDelay, boolean sendToDLAOnNoRoute, String addressFullMessagePolicy, long slowConsumerThreshold, long slowConsumerCheckPeriod, String slowConsumerPolicy, boolean autoCreateJmsQueues, boolean autoDeleteJmsQueues, boolean autoCreateJmsTopics, boolean autoDeleteJmsTopics, boolean autoCreateQueues, boolean autoDeleteQueues, boolean autoCreateAddresses, boolean autoDeleteAddresses)` adds a new address setting for a specific address
    `void` | `addAddressSettings(String addressMatch, String DLA, String expiryAddress, long expiryDelay, boolean lastValueQueue, int deliveryAttempts, long maxSizeBytes, int pageSizeBytes, int pageMaxCacheSize, long redeliveryDelay, double redeliveryMultiplier, long maxRedeliveryDelay, long redistributionDelay, boolean sendToDLAOnNoRoute, String addressFullMessagePolicy, long slowConsumerThreshold, long slowConsumerCheckPeriod, String slowConsumerPolicy, boolean autoCreateJmsQueues, boolean autoDeleteJmsQueues, boolean autoCreateJmsTopics, boolean autoDeleteJmsTopics, boolean autoCreateQueues, boolean autoDeleteQueues, boolean autoCreateAddresses, boolean autoDeleteAddresses, String configDeleteQueues, String configDeleteAddresses, long maxSizeBytesRejectThreshold, String defaultLastValueKey, boolean defaultNonDestructive, boolean defaultExclusiveQueue, boolean defaultGroupRebalance, int defaultGroupBuckets, String defaultGroupFirstKey, int defaultMaxConsumers, boolean defaultPurgeOnNoConsumers, int defaultConsumersBeforeDispatch, long defaultDelayBeforeDispatch, String defaultQueueRoutingType, String defaultAddressRoutingType, int defaultConsumerWindowSize, long defaultRingSize, boolean autoDeleteCreatedQueues, long autoDeleteQueuesDelay, long autoDeleteQueuesMessageCount, long autoDeleteAddressesDelay, double redeliveryCollisionAvoidanceFactor, long retroactiveMessageCount)` adds a new address setting for a specific address
    `void` | `addAddressSettings(String addressMatch, String DLA, String expiryAddress, long expiryDelay, boolean lastValueQueue, int deliveryAttempts, long maxSizeBytes, int pageSizeBytes, int pageMaxCacheSize, long redeliveryDelay, double redeliveryMultiplier, long maxRedeliveryDelay, long redistributionDelay, boolean sendToDLAOnNoRoute, String addressFullMessagePolicy, long slowConsumerThreshold, long slowConsumerCheckPeriod, String slowConsumerPolicy, boolean autoCreateJmsQueues, boolean autoDeleteJmsQueues, boolean autoCreateJmsTopics, boolean autoDeleteJmsTopics, boolean autoCreateQueues, boolean autoDeleteQueues, boolean autoCreateAddresses, boolean autoDeleteAddresses, String configDeleteQueues, String configDeleteAddresses, long maxSizeBytesRejectThreshold, String defaultLastValueKey, boolean defaultNonDestructive, boolean defaultExclusiveQueue, boolean defaultGroupRebalance, int defaultGroupBuckets, String defaultGroupFirstKey, int defaultMaxConsumers, boolean defaultPurgeOnNoConsumers, int defaultConsumersBeforeDispatch, long defaultDelayBeforeDispatch, String defaultQueueRoutingType, String defaultAddressRoutingType, int defaultConsumerWindowSize, long defaultRingSize, boolean autoDeleteCreatedQueues, long autoDeleteQueuesDelay, long autoDeleteQueuesMessageCount, long autoDeleteAddressesDelay, double redeliveryCollisionAvoidanceFactor, long retroactiveMessageCount, boolean autoCreateDeadLetterResources, String deadLetterQueuePrefix, String deadLetterQueueSuffix, boolean autoCreateExpiryResources, String expiryQueuePrefix, String expiryQueueSuffix)` adds a new address setting for a specific address
    `void` | `addSecuritySettings(String addressMatch, String sendRoles, String consumeRoles, String createDurableQueueRoles, String deleteDurableQueueRoles, String createNonDurableQueueRoles, String deleteNonDurableQueueRoles, String manageRoles)`
    `void` | `addSecuritySettings(String addressMatch, String sendRoles, String consumeRoles, String createDurableQueueRoles, String deleteDurableQueueRoles, String createNonDurableQueueRoles, String deleteNonDurableQueueRoles, String manageRoles, String browseRoles)`
    `void` | `addSecuritySettings(String addressMatch, String sendRoles, String consumeRoles, String createDurableQueueRoles, String deleteDurableQueueRoles, String createNonDurableQueueRoles, String deleteNonDurableQueueRoles, String manageRoles, String browseRoles, String createAddressRoles, String deleteAddressRoles)`
    `void` | `addUser(String username, String password, String roles, boolean plaintext)` Add a user (only applicable when using the JAAS PropertiesLoginModule)
    `boolean` | `closeConnectionsForAddress(String ipAddress)` Closes all the connections of clients connected to this server which matches the specified IP address.
    `boolean` | `closeConnectionsForUser(String address)` Closes all the connections of sessions with a matching user name.
    `boolean` | `closeConnectionWithID(String ID)` Closes the connection with the given id.
    `boolean` | `closeConsumerConnectionsForAddress(String address)` Closes all the connections of clients connected to this server which matches the specified IP address.
    `boolean` | `closeConsumerWithID(String sessionID, String ID)` Closes the consumer with the given id.
    `boolean` | `closeSessionWithID(String connectionID, String ID)` Closes the session with the given id.
    `boolean` | `commitPreparedTransaction(String transactionAsBase64)` Heuristically commits a prepared transaction.
    `String` | `createAddress(String name, String routingTypes)`
    `void` | `createBridge(String name, String queueName, String forwardingAddress, String filterString, String transformerClassName, long retryInterval, double retryIntervalMultiplier, int initialConnectAttempts, int reconnectAttempts, boolean useDuplicateDetection, int confirmationWindowSize, int producerWindowSize, long clientFailureCheckPeriod, String connectorNames, boolean useDiscoveryGroup, boolean ha, String user, String password)`
    `void` | `createBridge(String name, String queueName, String forwardingAddress, String filterString, String transformerClassName, long retryInterval, double retryIntervalMultiplier, int initialConnectAttempts, int reconnectAttempts, boolean useDuplicateDetection, int confirmationWindowSize, long clientFailureCheckPeriod, String connectorNames, boolean useDiscoveryGroup, boolean ha, String user, String password)`
    `void` | `createBridge(String name, String queueName, String forwardingAddress, String filterString, String transformerClassName, Map<String,String> transformerProperties, long retryInterval, double retryIntervalMultiplier, int initialConnectAttempts, int reconnectAttempts, boolean useDuplicateDetection, int confirmationWindowSize, int producerWindowSize, long clientFailureCheckPeriod, String connectorNames, boolean useDiscoveryGroup, boolean ha, String user, String password)`
    `void` | `createBridge(String name, String queueName, String forwardingAddress, String filterString, String transformerClassName, String transformerPropertiesAsJSON, long retryInterval, double retryIntervalMultiplier, int initialConnectAttempts, int reconnectAttempts, boolean useDuplicateDetection, int confirmationWindowSize, int producerWindowSize, long clientFailureCheckPeriod, String connectorNames, boolean useDiscoveryGroup, boolean ha, String user, String password)`
    `void` | `createConnectorService(String name, String factoryClass, Map<String,Object> parameters)`
    `void` | `createDivert(String name, String routingName, String address, String forwardingAddress, boolean exclusive, String filterString, String transformerClassName)`
    `void` | `createDivert(String name, String routingName, String address, String forwardingAddress, boolean exclusive, String filterString, String transformerClassName, Map<String,String> transformerProperties, String routingType)`
    `void` | `createDivert(String name, String routingName, String address, String forwardingAddress, boolean exclusive, String filterString, String transformerClassName, String routingType)`
    `void` | `createDivert(String name, String routingName, String address, String forwardingAddress, boolean exclusive, String filterString, String transformerClassName, String transformerPropertiesAsJSON, String routingType)`
    `String` | `createQueue(String queueConfiguration)` Create a queue.
    `String` | `createQueue(String queueConfiguration, boolean ignoreIfExists)` Create a queue.
    `void` | `createQueue(String address, String name)` Deprecated.
    `void` | `createQueue(String address, String name, boolean durable)` Deprecated.
    `void` | `createQueue(String address, String name, boolean durable, String routingType)` Deprecated.
    `void` | `createQueue(String address, String name, String routingType)` Deprecated.
    `void` | `createQueue(String address, String name, String filter, boolean durable)` Deprecated.
    `void` | `createQueue(String address, String name, String filter, boolean durable, String routingType)` Deprecated.
    `String` | `createQueue(String address, String routingType, String name, String filterStr, boolean durable, int maxConsumers, boolean purgeOnNoConsumers, boolean autoCreateAddress)` Deprecated.
    `String` | `createQueue(String address, String routingType, String name, String filterStr, boolean durable, int maxConsumers, boolean purgeOnNoConsumers, boolean exclusive, boolean groupRebalance, int groupBuckets, boolean lastValue, String lastValueKey, boolean nonDestructive, int consumersBeforeDispatch, long delayBeforeDispatch, boolean autoCreateAddress)` Deprecated.
    `String` | `createQueue(String address, String routingType, String name, String filterStr, boolean durable, int maxConsumers, boolean purgeOnNoConsumers, boolean exclusive, boolean groupRebalance, int groupBuckets, boolean lastValue, String lastValueKey, boolean nonDestructive, int consumersBeforeDispatch, long delayBeforeDispatch, boolean autoDelete, long autoDeleteDelay, long autoDeleteMessageCount, boolean autoCreateAddress)` Deprecated.
    `String` | `createQueue(String address, String routingType, String name, String filterStr, boolean durable, int maxConsumers, boolean purgeOnNoConsumers, boolean exclusive, boolean groupRebalance, int groupBuckets, String groupFirstKey, boolean lastValue, String lastValueKey, boolean nonDestructive, int consumersBeforeDispatch, long delayBeforeDispatch, boolean autoDelete, long autoDeleteDelay, long autoDeleteMessageCount, boolean autoCreateAddress)` Deprecated.
    `String` | `createQueue(String address, String routingType, String name, String filterStr, boolean durable, int maxConsumers, boolean purgeOnNoConsumers, boolean exclusive, boolean groupRebalance, int groupBuckets, String groupFirstKey, boolean lastValue, String lastValueKey, boolean nonDestructive, int consumersBeforeDispatch, long delayBeforeDispatch, boolean autoDelete, long autoDeleteDelay, long autoDeleteMessageCount, boolean autoCreateAddress, long ringSize)` Deprecated.
    `void` | `deleteAddress(String name)`
    `void` | `deleteAddress(String name, boolean force)`
    `void` | `deployQueue(String address, String name, String filter)` Deprecated.
    `void` | `deployQueue(String address, String name, String filter, boolean durable)` Deprecated.
    `void` | `destroyBridge(String name)`
    `void` | `destroyConnectorService(String name)`
    `void` | `destroyDivert(String name)`
    `void` | `destroyQueue(String name)` Destroys the queue corresponding to the specified name.
    `void` | `destroyQueue(String name, boolean removeConsumers)` Destroys the queue corresponding to the specified name.
    `void` | `destroyQueue(String name, boolean removeConsumers, boolean autoDeleteAddress)` Destroys the queue corresponding to the specified name and delete it's address if there are no other queues
    `void` | `disableMessageCounters()` Disables message counters for this server.
    `void` | `enableMessageCounters()` Enables message counters for this server.
    `void` | `forceFailover()`
    `boolean` | `freezeReplication()`
    `String` | `getAddressInfo(String address)`
    `long` | `getAddressMemoryUsage()` Returns the memory used by all the addresses on broker for in-memory messages
    `int` | `getAddressMemoryUsagePercentage()` Returns the memory used by all the addresses on broker as a percentage of global maximum limit
    `String[]` | `getAddressNames()` Returns the addresses created on this server.
    `String` | `getAddressSettingsAsJSON(String addressMatch)` returns the address settings as a JSON string
    `String` | `getBindingsDirectory()` Returns the file system directory used to store bindings.
    `String[]` | `getBridgeNames()`
    `String[]` | `getClusterConnectionNames()` Returns the names of the cluster-connections deployed on this server.
    `int` | `getConnectionCount()` Returns the number of clients connected to this server.
    `long` | `getConnectionTTLOverride()` Returns the connection time to live.
    `Object[]` | `getConnectors()` Returns the connectors configured for this server.
    `String` | `getConnectorsAsJSON()` Returns the connectors configured for this server using JSON serialization.
    `String[]` | `getConnectorServices()`
    `int` | `getDiskScanPeriod()` Returns how often the server checks for disk space usage.
    `long` | `getDiskStoreUsage()` Returns the bytes used by the disk store
    `int` | `getDiskStoreUsagePercentage()` Returns the storage used by disk store
    `String[]` | `getDivertNames()`
    `long` | `getGlobalMaxSize()` Returns the global max bytes limit for in-memory messages.
    `int` | `getIDCacheSize()` Returns the size of the cache for pre-creating message IDs.
    `String[]` | `getIncomingInterceptorClassNames()` Returns the list of interceptors used by this server for incoming messages.
    `int` | `getJournalBufferSize()` Returns the size of the internal buffer on the journal.
    `int` | `getJournalBufferTimeout()` Returns the timeout (in nanoseconds) used to flush internal buffers on the journal.
    `int` | `getJournalCompactMinFiles()` Returns the minimal number of journal files before compacting.
    `int` | `getJournalCompactPercentage()` Return the percentage of live data before compacting the journal.
    `String` | `getJournalDirectory()` Returns the file system directory used to store journal log.
    `int` | `getJournalFileSize()` Returns the size (in bytes) of each journal files.
    `int` | `getJournalMaxIO()` Returns the maximum number of write requests that can be in the AIO queue at any given time.
    `int` | `getJournalMinFiles()` Returns the number of journal files to pre-create.
    `String` | `getJournalType()` Returns the type of journal used by this server (either `NIO` or `ASYNCIO`).
    `String` | `getLargeMessagesDirectory()` Returns the file system directory used to store large messages.
    `String` | `getManagementAddress()` Returns the management address of this server.
    `String` | `getManagementNotificationAddress()` Returns the management notification address of this server.
    `int` | `getMaxDiskUsage()` Returns the disk use max limit.
    `int` | `getMessageCounterMaxDayCount()` Returns the maximum number of days kept in memory for message counter.
    `long` | `getMessageCounterSamplePeriod()` Returns the sample period (in milliseconds) to take message counter snapshot.
    `long` | `getMessageExpiryScanPeriod()` Returns the frequency (in milliseconds) to scan messages to detect which messages have expired.
    `long` | `getMessageExpiryThreadPriority()` Deprecated.
    `String` | `getNodeID()` Returns the node ID of this server.
    `String[]` | `getOutgoingInterceptorClassNames()` Returns the list of interceptors used by this server for outgoing messages.
    `String` | `getPagingDirectory()` Returns the file system directory used to store paging files.
    `String[]` | `getQueueNames()` Returns the names of the queues created on this server.
    `String[]` | `getQueueNames(String routingType)` Returns the names of the queues created on this server with the given routing-type.
    `Object[]` | `getRoles(String addressMatch)`
    `String` | `getRolesAsJSON(String addressMatch)`
    `int` | `getScheduledThreadPoolMaxSize()` Returns the maximum number of threads in the scheduled thread pool.
    `long` | `getSecurityInvalidationInterval()` Returns the interval time (in milliseconds) to invalidate security credentials.
    `int` | `getThreadPoolMaxSize()` Returns the maximum number of threads in the thread pool.
    `long` | `getTotalConnectionCount()` Returns the number of clients which have connected to this server since it was started.
    `long` | `getTotalConsumerCount()` Returns the number of messages sent to this server since it was started.
    `long` | `getTotalMessageCount()` Returns the number of messages in all queues on the server.
    `long` | `getTotalMessagesAcknowledged()` Returns the number of messages sent to this server since it was started.
    `long` | `getTotalMessagesAdded()` Returns the number of messages sent to this server since it was started.
    `long` | `getTransactionTimeout()` Returns the timeout (in milliseconds) after which transactions is removed from the resource manager after it was created.
    `long` | `getTransactionTimeoutScanPeriod()` Returns the frequency (in milliseconds) to scan transactions to detect which transactions have timed out.
    `String` | `getUptime()` Returns the uptime of this server.
    `long` | `getUptimeMillis()` Returns the uptime of this server.
    `String` | `getVersion()` Returns this server's version.
    `boolean` | `isAsyncConnectionExecutionEnabled()` Returns whether code coming from connection is executed asynchronously or not.
    `boolean` | `isBackup()` Returns `true` if this server is a backup, `false` if it is a live server.
    `boolean` | `isClustered()` Returns whether this server is clustered.
    `boolean` | `isCreateBindingsDir()` Returns whether the bindings directory is created on this server startup.
    `boolean` | `isCreateJournalDir()` Returns whether the journal directory is created on this server startup.
    `boolean` | `isFailoverOnServerShutdown()` returns if clients failover on a server shutdown
    `boolean` | `isJournalSyncNonTransactional()` Returns whether the journal is synchronized when receiving non-transactional data.
    `boolean` | `isJournalSyncTransactional()` Returns whether the journal is synchronized when receiving transactional data.
    `boolean` | `isMessageCounterEnabled()` Returns whether message counter is enabled for this server.
    `boolean` | `isPersistDeliveryCountBeforeDelivery()` Returns whether delivery count is persisted before messages are delivered to the consumers.
    `boolean` | `isPersistenceEnabled()` Returns whether this server is using persistence and store data.
    `boolean` | `isPersistIDCache()` Returns whether message ID cache is persisted.
    `boolean` | `isReplicaSync()` Returns whether the initial replication synchronization process with the backup server is complete; applicable for either the live or backup server.
    `boolean` | `isSecurityEnabled()` Returns whether security is enabled for this server.
    `boolean` | `isSharedStore()` Returns whether this server shares its data store with a corresponding live or backup server.
    `boolean` | `isStarted()` Return whether this server is started.
    `boolean` | `isWildcardRoutingEnabled()` Returns whether wildcard routing is supported by this server.
    `String` | `listAddresses(String separator)`
    `String` | `listAddresses(String options, int page, int pageSize)`
    `String` | `listAllConsumersAsJSON()` Lists all the consumers connected to this server.
    `String` | `listAllSessionsAsJSON()` Lists details about all sessions.
    `String` | `listBindingsForAddress(String address)`
    `String[]` | `listConnectionIDs()` Lists all the IDs of the connections connected to this server.
    `String` | `listConnections(String options, int page, int pageSize)`
    `String` | `listConnectionsAsJSON()` Lists all the connections connected to this server.
    `String` | `listConsumers(String options, int page, int pageSize)`
    `String` | `listConsumersAsJSON(String connectionID)` Lists all the consumers which belongs to the connection specified by the connectionID.
    `default String[]` | `listDivertNames()` Jon plugin doesn't recognize an Operation whose name is in form getXXXX(), so add this one.
    `String[]` | `listHeuristicCommittedTransactions()` List transactions which have been heuristically committed.
    `String[]` | `listHeuristicRolledBackTransactions()` List transactions which have been heuristically rolled back.
    `String` | `listNetworkTopology()`
    `String` | `listPreparedTransactionDetailsAsHTML()` List all the prepared transaction, sorted by date, oldest first, with details, in HTML format
    `String` | `listPreparedTransactionDetailsAsJSON()` List all the prepared transaction, sorted by date, oldest first, with details, in text format.
    `String[]` | `listPreparedTransactions()` List all the prepared transaction, sorted by date, oldest first.
    `String` | `listProducers(String options, int page, int pageSize)`
    `String` | `listProducersInfoAsJSON()`
    `String` | `listQueues(String options, int page, int pageSize)`
    `String[]` | `listRemoteAddresses()` Lists the addresses of all the clients connected to this address.
    `String[]` | `listRemoteAddresses(String ipAddress)` Lists the addresses of the clients connected to this address which matches the specified IP address.
    `String[]` | `listSessions(String connectionID)` Lists all the sessions IDs for the specified connection ID.
    `String` | `listSessions(String options, int page, int pageSize)`
    `String` | `listSessionsAsJSON(String connectionID)` Lists details about all the sessions for the specified connection ID.
    `String` | `listUser(String username)` List the information about a user or all users if no username is supplied (only applicable when using the JAAS PropertiesLoginModule).
    `void` | `removeAddressSettings(String addressMatch)`
    `void` | `removeSecuritySettings(String addressMatch)`
    `void` | `removeUser(String username)` Remove a user (only applicable when using the JAAS PropertiesLoginModule).
    `void` | `resetAllMessageCounterHistories()` Reset histories for all message counters.
    `void` | `resetAllMessageCounters()` Reset all message counters.
    `void` | `resetUser(String username, String password, String roles)` Set new properties on an existing user (only applicable when using the JAAS PropertiesLoginModule).
    `void` | `resetUser(String username, String password, String roles, boolean plaintext)` Set new properties on an existing user (only applicable when using the JAAS PropertiesLoginModule).
    `boolean` | `rollbackPreparedTransaction(String transactionAsBase64)` Heuristically rolls back a prepared transaction.
    `void` | `scaleDown(String connector)`
    `void` | `setFailoverOnServerShutdown(boolean failoverOnServerShutdown)` do any clients failover on a server shutdown
    `void` | `setMessageCounterMaxDayCount(int count)` Sets the maximum number of days kept in memory for message counter.
    `void` | `setMessageCounterSamplePeriod(long newPeriod)` Sets the sample period to take message counter snapshot.
    `String` | `updateAddress(String name, String routingTypes)`
    `String` | `updateQueue(String queueConfiguration)` Update a queue.
    `String` | `updateQueue(String name, String routingType, Integer maxConsumers, Boolean purgeOnNoConsumers)` Deprecated.
    `String` | `updateQueue(String name, String routingType, Integer maxConsumers, Boolean purgeOnNoConsumers, Boolean exclusive)` Deprecated.
    `String` | `updateQueue(String name, String routingType, Integer maxConsumers, Boolean purgeOnNoConsumers, Boolean exclusive, String user)` Deprecated.
    `String` | `updateQueue(String name, String routingType, String filter, Integer maxConsumers, Boolean purgeOnNoConsumers, Boolean exclusive, Boolean groupRebalance, Integer groupBuckets, Boolean nonDestructive, Integer consumersBeforeDispatch, Long delayBeforeDispatch, String user)` Deprecated.
    `String` | `updateQueue(String name, String routingType, String filter, Integer maxConsumers, Boolean purgeOnNoConsumers, Boolean exclusive, Boolean groupRebalance, Integer groupBuckets, String groupFirstKey, Boolean nonDestructive, Integer consumersBeforeDispatch, Long delayBeforeDispatch, String user)` Deprecated.
    `String` | `updateQueue(String name, String routingType, String filter, Integer maxConsumers, Boolean purgeOnNoConsumers, Boolean exclusive, Boolean groupRebalance, Integer groupBuckets, String groupFirstKey, Boolean nonDestructive, Integer consumersBeforeDispatch, Long delayBeforeDispatch, String user, Long ringSize)` Deprecated.

- - ### Field Detail

    - #### CONNECTION_COUNT_DESCRIPTION

          static final String CONNECTION_COUNT_DESCRIPTION

      See Also:
        Constant Field Values

    - #### TOTAL_CONNECTION_COUNT_DESCRIPTION

          static final String TOTAL_CONNECTION_COUNT_DESCRIPTION

      See Also:
        Constant Field Values

    - #### ADDRESS_MEMORY_USAGE_DESCRIPTION

          static final String ADDRESS_MEMORY_USAGE_DESCRIPTION

      See Also:
        Constant Field Values

    - #### DISK_STORE_USAGE_DESCRIPTION

          static final String DISK_STORE_USAGE_DESCRIPTION

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getVersion

          String getVersion()

      Returns this server's version.

    - #### getConnectionCount

          int getConnectionCount()

      Returns the number of clients connected to this server.

    - #### getTotalConnectionCount

          long getTotalConnectionCount()

      Returns the number of clients which have connected to this server since it was started.

    - #### getTotalMessageCount

          long getTotalMessageCount()

      Returns the number of messages in all queues on the server.

    - #### getTotalMessagesAdded

          long getTotalMessagesAdded()

      Returns the number of messages sent to this server since it was started.

    - #### getTotalMessagesAcknowledged

          long getTotalMessagesAcknowledged()

      Returns the number of messages sent to this server since it was started.

    - #### getTotalConsumerCount

          long getTotalConsumerCount()

      Returns the number of messages sent to this server since it was started.

    - #### isStarted

          boolean isStarted()

      Return whether this server is started.

    - #### getIncomingInterceptorClassNames

          String[] getIncomingInterceptorClassNames()

      Returns the list of interceptors used by this server for incoming messages.
      See Also:
        `Interceptor`

    - #### getOutgoingInterceptorClassNames

          String[] getOutgoingInterceptorClassNames()

      Returns the list of interceptors used by this server for outgoing messages.
      See Also:
        `Interceptor`

    - #### isClustered

          boolean isClustered()

      Returns whether this server is clustered.

    - #### getScheduledThreadPoolMaxSize

          int getScheduledThreadPoolMaxSize()

      Returns the maximum number of threads in the scheduled thread pool.

    - #### getThreadPoolMaxSize

          int getThreadPoolMaxSize()

      Returns the maximum number of threads in the thread pool.

    - #### getSecurityInvalidationInterval

          long getSecurityInvalidationInterval()

      Returns the interval time (in milliseconds) to invalidate security credentials.

    - #### isSecurityEnabled

          boolean isSecurityEnabled()

      Returns whether security is enabled for this server.

    - #### getBindingsDirectory

          String getBindingsDirectory()

      Returns the file system directory used to store bindings.

    - #### getJournalDirectory

          String getJournalDirectory()

      Returns the file system directory used to store journal log.

    - #### getJournalType

          String getJournalType()

      Returns the type of journal used by this server (either `NIO` or `ASYNCIO`).

    - #### isJournalSyncTransactional

          boolean isJournalSyncTransactional()

      Returns whether the journal is synchronized when receiving transactional data.

    - #### isJournalSyncNonTransactional

          boolean isJournalSyncNonTransactional()

      Returns whether the journal is synchronized when receiving non-transactional data.

    - #### getJournalFileSize

          int getJournalFileSize()

      Returns the size (in bytes) of each journal files.

    - #### getJournalMinFiles

          int getJournalMinFiles()

      Returns the number of journal files to pre-create.

    - #### getJournalMaxIO

          int getJournalMaxIO()

      Returns the maximum number of write requests that can be in the AIO queue at any given time.

    - #### getJournalBufferSize

          int getJournalBufferSize()

      Returns the size of the internal buffer on the journal.

    - #### getJournalBufferTimeout

          int getJournalBufferTimeout()

      Returns the timeout (in nanoseconds) used to flush internal buffers on the journal.

    - #### setFailoverOnServerShutdown

          void setFailoverOnServerShutdown(boolean failoverOnServerShutdown)
                                    throws Exception

      do any clients failover on a server shutdown
      Throws:
        `Exception`

    - #### isFailoverOnServerShutdown

          boolean isFailoverOnServerShutdown()

      returns if clients failover on a server shutdown

    - #### getJournalCompactMinFiles

          int getJournalCompactMinFiles()

      Returns the minimal number of journal files before compacting.

    - #### getJournalCompactPercentage

          int getJournalCompactPercentage()

      Return the percentage of live data before compacting the journal.

    - #### isPersistenceEnabled

          boolean isPersistenceEnabled()

      Returns whether this server is using persistence and store data.

    - #### isCreateBindingsDir

          boolean isCreateBindingsDir()

      Returns whether the bindings directory is created on this server startup.

    - #### isCreateJournalDir

          boolean isCreateJournalDir()

      Returns whether the journal directory is created on this server startup.

    - #### isMessageCounterEnabled

          boolean isMessageCounterEnabled()

      Returns whether message counter is enabled for this server.

    - #### getMessageCounterMaxDayCount

          int getMessageCounterMaxDayCount()

      Returns the maximum number of days kept in memory for message counter.

    - #### setMessageCounterMaxDayCount

          void setMessageCounterMaxDayCount(int count)
                                     throws Exception

      Sets the maximum number of days kept in memory for message counter.
      Parameters:
        `count` - value must be greater than 0
      Throws:
        `Exception`

    - #### getMessageCounterSamplePeriod

          long getMessageCounterSamplePeriod()

      Returns the sample period (in milliseconds) to take message counter snapshot.

    - #### setMessageCounterSamplePeriod

          void setMessageCounterSamplePeriod(long newPeriod)
                                      throws Exception

      Sets the sample period to take message counter snapshot.
      Parameters:
        `newPeriod` - value must be greater than 1000ms
      Throws:
        `Exception`

    - #### isBackup

          boolean isBackup()

      Returns `true` if this server is a backup, `false` if it is a live server.
      If a backup server has been activated, returns `false`.

    - #### isSharedStore

          boolean isSharedStore()

      Returns whether this server shares its data store with a corresponding live or backup server.

    - #### getPagingDirectory

          String getPagingDirectory()

      Returns the file system directory used to store paging files.

    - #### isPersistDeliveryCountBeforeDelivery

          boolean isPersistDeliveryCountBeforeDelivery()

      Returns whether delivery count is persisted before messages are delivered to the consumers.

    - #### getConnectionTTLOverride

          long getConnectionTTLOverride()

      Returns the connection time to live.
      This value overrides the connection time to live sent by the client.

    - #### getManagementAddress

          String getManagementAddress()

      Returns the management address of this server.
      Clients can send management messages to this address to manage this server.

    - #### getNodeID

          String getNodeID()

      Returns the node ID of this server.
      Clients can send management messages to this address to manage this server.

    - #### getManagementNotificationAddress

          String getManagementNotificationAddress()

      Returns the management notification address of this server.
      Clients can bind queues to this address to receive management notifications emitted by this server.

    - #### getIDCacheSize

          int getIDCacheSize()

      Returns the size of the cache for pre-creating message IDs.

    - #### isPersistIDCache

          boolean isPersistIDCache()

      Returns whether message ID cache is persisted.

    - #### getLargeMessagesDirectory

          String getLargeMessagesDirectory()

      Returns the file system directory used to store large messages.

    - #### isWildcardRoutingEnabled

          boolean isWildcardRoutingEnabled()

      Returns whether wildcard routing is supported by this server.

    - #### getTransactionTimeout

          long getTransactionTimeout()

      Returns the timeout (in milliseconds) after which transactions is removed from the resource manager after it was created.

    - #### getTransactionTimeoutScanPeriod

          long getTransactionTimeoutScanPeriod()

      Returns the frequency (in milliseconds) to scan transactions to detect which transactions have timed out.

    - #### getMessageExpiryScanPeriod

          long getMessageExpiryScanPeriod()

      Returns the frequency (in milliseconds) to scan messages to detect which messages have expired.

    - #### getMessageExpiryThreadPriority

          @Deprecated
          long getMessageExpiryThreadPriority()

      Deprecated.
      Returns the priority of the thread used to scan message expiration.

    - #### isAsyncConnectionExecutionEnabled

          boolean isAsyncConnectionExecutionEnabled()

      Returns whether code coming from connection is executed asynchronously or not.

    - #### getConnectors

          Object[] getConnectors()
                          throws Exception

      Returns the connectors configured for this server.
      Throws:
        `Exception`

    - #### getConnectorsAsJSON

          String getConnectorsAsJSON()
                              throws Exception

      Returns the connectors configured for this server using JSON serialization.
      Throws:
        `Exception`

    - #### getAddressNames

          String[] getAddressNames()

      Returns the addresses created on this server.

    - #### getQueueNames

          String[] getQueueNames()

      Returns the names of the queues created on this server.

    - #### getUptime

          String getUptime()

      Returns the uptime of this server.

    - #### getUptimeMillis

          long getUptimeMillis()

      Returns the uptime of this server.

    - #### isReplicaSync

          boolean isReplicaSync()

      Returns whether the initial replication synchronization process with the backup server is complete; applicable for either the live or backup server.

    - #### getDiskScanPeriod

          int getDiskScanPeriod()

      Returns how often the server checks for disk space usage.

    - #### getMaxDiskUsage

          int getMaxDiskUsage()

      Returns the disk use max limit.

    - #### getGlobalMaxSize

          long getGlobalMaxSize()

      Returns the global max bytes limit for in-memory messages.

    - #### getAddressMemoryUsage

          long getAddressMemoryUsage()

      Returns the memory used by all the addresses on broker for in-memory messages

    - #### getDiskStoreUsage

          long getDiskStoreUsage()

      Returns the bytes used by the disk store

    - #### getAddressMemoryUsagePercentage

          int getAddressMemoryUsagePercentage()

      Returns the memory used by all the addresses on broker as a percentage of global maximum limit

    - #### getDiskStoreUsagePercentage

          int getDiskStoreUsagePercentage()

      Returns the storage used by disk store

    - #### freezeReplication

          boolean freezeReplication()

    - #### createAddress

          String createAddress(String name,
                               String routingTypes)
                        throws Exception

      Throws:
        `Exception`

    - #### updateAddress

          String updateAddress(String name,
                               String routingTypes)
                        throws Exception

      Throws:
        `Exception`

    - #### deleteAddress

          void deleteAddress(String name)
                      throws Exception

      Throws:
        `Exception`

    - #### deleteAddress

          void deleteAddress(String name,
                             boolean force)
                      throws Exception

      Throws:
        `Exception`

    - #### createQueue

          @Deprecated
          void createQueue(String address,
                                       String name)
                                throws Exception

      Deprecated.
      Create a durable queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
      Throws:
        `Exception`

    - #### createQueue

          @Deprecated
          void createQueue(String address,
                                       String name,
                                       String routingType)
                                throws Exception

      Deprecated.
      Create a durable queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `routingType` - The routing type used for this address, MULTICAST or ANYCAST
      Throws:
        `Exception`

    - #### createQueue

          @Deprecated
          void createQueue(String address,
                                       String name,
                                       boolean durable)
                                throws Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `durable` - whether the queue is durable
      Throws:
        `Exception`

    - #### createQueue

          @Deprecated
          void createQueue(String address,
                                       String name,
                                       boolean durable,
                                       String routingType)
                                throws Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `durable` - whether the queue is durable
        `routingType` - The routing type used for this address, MULTICAST or ANYCAST
      Throws:
        `Exception`

    - #### createQueue

          @Deprecated
          void createQueue(String address,
                                       String name,
                                       String filter,
                                       boolean durable)
                                throws Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `filter` - of the queue
        `durable` - whether the queue is durable
      Throws:
        `Exception`

    - #### createQueue

          @Deprecated
          void createQueue(String address,
                                       String name,
                                       String filter,
                                       boolean durable,
                                       String routingType)
                                throws Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `filter` - of the queue
        `durable` - whether the queue is durable
        `routingType` - The routing type used for this address, MULTICAST or ANYCAST
      Throws:
        `Exception`

    - #### createQueue

          @Deprecated
          String createQueue(String address,
                                         String routingType,
                                         String name,
                                         String filterStr,
                                         boolean durable,
                                         int maxConsumers,
                                         boolean purgeOnNoConsumers,
                                         boolean exclusive,
                                         boolean groupRebalance,
                                         int groupBuckets,
                                         boolean lastValue,
                                         String lastValueKey,
                                         boolean nonDestructive,
                                         int consumersBeforeDispatch,
                                         long delayBeforeDispatch,
                                         boolean autoCreateAddress)
                                  throws Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `name` - name of the queue
        `filterStr` - filter of the queue
        `durable` - is the queue durable?
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
        `lastValue` - use last-value semantics
        `consumersBeforeDispatch` - number of consumers needed before dispatch can start
        `delayBeforeDispatch` - delay to wait before dispatching if number of consumers before dispatch is not met
        `autoCreateAddress` - create an address with default values should a matching address not be found
      Returns:
        a textual summary of the queue
      Throws:
        `Exception`

    - #### createQueue

          @Deprecated
          String createQueue(String address,
                                         String routingType,
                                         String name,
                                         String filterStr,
                                         boolean durable,
                                         int maxConsumers,
                                         boolean purgeOnNoConsumers,
                                         boolean exclusive,
                                         boolean groupRebalance,
                                         int groupBuckets,
                                         boolean lastValue,
                                         String lastValueKey,
                                         boolean nonDestructive,
                                         int consumersBeforeDispatch,
                                         long delayBeforeDispatch,
                                         boolean autoDelete,
                                         long autoDeleteDelay,
                                         long autoDeleteMessageCount,
                                         boolean autoCreateAddress)
                                  throws Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `name` - name of the queue
        `filterStr` - filter of the queue
        `durable` - is the queue durable?
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
        `lastValue` - use last-value semantics
        `consumersBeforeDispatch` - number of consumers needed before dispatch can start
        `delayBeforeDispatch` - delay to wait before dispatching if number of consumers before dispatch is not met
        `autoCreateAddress` - create an address with default values should a matching address not be found
      Returns:
        a textual summary of the queue
      Throws:
        `Exception`

    - #### createQueue

          @Deprecated
          String createQueue(String address,
                                         String routingType,
                                         String name,
                                         String filterStr,
                                         boolean durable,
                                         int maxConsumers,
                                         boolean purgeOnNoConsumers,
                                         boolean exclusive,
                                         boolean groupRebalance,
                                         int groupBuckets,
                                         String groupFirstKey,
                                         boolean lastValue,
                                         String lastValueKey,
                                         boolean nonDestructive,
                                         int consumersBeforeDispatch,
                                         long delayBeforeDispatch,
                                         boolean autoDelete,
                                         long autoDeleteDelay,
                                         long autoDeleteMessageCount,
                                         boolean autoCreateAddress)
                                  throws Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `name` - name of the queue
        `filterStr` - filter of the queue
        `durable` - is the queue durable?
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
        `lastValue` - use last-value semantics
        `consumersBeforeDispatch` - number of consumers needed before dispatch can start
        `delayBeforeDispatch` - delay to wait before dispatching if number of consumers before dispatch is not met
        `autoCreateAddress` - create an address with default values should a matching address not be found
      Returns:
        a textual summary of the queue
      Throws:
        `Exception`

    - #### createQueue

          @Deprecated
          String createQueue(String address,
                                         String routingType,
                                         String name,
                                         String filterStr,
                                         boolean durable,
                                         int maxConsumers,
                                         boolean purgeOnNoConsumers,
                                         boolean exclusive,
                                         boolean groupRebalance,
                                         int groupBuckets,
                                         String groupFirstKey,
                                         boolean lastValue,
                                         String lastValueKey,
                                         boolean nonDestructive,
                                         int consumersBeforeDispatch,
                                         long delayBeforeDispatch,
                                         boolean autoDelete,
                                         long autoDeleteDelay,
                                         long autoDeleteMessageCount,
                                         boolean autoCreateAddress,
                                         long ringSize)
                                  throws Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `name` - name of the queue
        `filterStr` - filter of the queue
        `durable` - is the queue durable?
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
        `lastValue` - use last-value semantics
        `consumersBeforeDispatch` - number of consumers needed before dispatch can start
        `delayBeforeDispatch` - delay to wait before dispatching if number of consumers before dispatch is not met
        `autoCreateAddress` - create an address with default values should a matching address not be found
        `ringSize` - the size this queue should maintain according to ring semantics
      Returns:
        a textual summary of the queue
      Throws:
        `Exception`

    - #### createQueue

          @Deprecated
          String createQueue(String address,
                                         String routingType,
                                         String name,
                                         String filterStr,
                                         boolean durable,
                                         int maxConsumers,
                                         boolean purgeOnNoConsumers,
                                         boolean autoCreateAddress)
                                  throws Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `name` - name of the queue
        `filterStr` - filter of the queue
        `durable` - is the queue durable?
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `autoCreateAddress` - create an address with default values should a matching address not be found
      Returns:
        a textual summary of the queue
      Throws:
        `Exception`

    - #### createQueue

          String createQueue(String queueConfiguration)
                      throws Exception

      Create a queue.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exists.
      Parameters:
        `queueConfiguration` - the configuration of the queue in JSON format
      Returns:
        the configuration of the created queue in JSON format
      Throws:
        `Exception`

    - #### createQueue

          String createQueue(String queueConfiguration,
                             boolean ignoreIfExists)
                      throws Exception

      Create a queue.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exists and `ignoreIfExists` is `false`.
      Parameters:
        `queueConfiguration` - the configuration of the queue in JSON format
        `ignoreIfExists` - whether or not to simply return without an exception if the queue exists
      Returns:
        the configuration of the created queue in JSON format
      Throws:
        `Exception`

    - #### updateQueue

          String updateQueue(String queueConfiguration)
                      throws Exception

      Update a queue.
      Parameters:
        `queueConfiguration` - the configuration of the queue in JSON format
      Returns:
        the configuration of the created queue in JSON format
      Throws:
        `Exception`

    - #### updateQueue

          @Deprecated
          String updateQueue(String name,
                                         String routingType,
                                         Integer maxConsumers,
                                         Boolean purgeOnNoConsumers)
                                  throws Exception

      Deprecated.
      Update a queue.
      Parameters:
        `name` - name of the queue
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
      Returns:
        a textual summary of the queue
      Throws:
        `Exception`

    - #### updateQueue

          @Deprecated
          String updateQueue(String name,
                                         String routingType,
                                         Integer maxConsumers,
                                         Boolean purgeOnNoConsumers,
                                         Boolean exclusive)
                                  throws Exception

      Deprecated.
      Update a queue.
      Parameters:
        `name` - name of the queue
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
      Returns:
        a textual summary of the queue
      Throws:
        `Exception`

    - #### updateQueue

          @Deprecated
          String updateQueue(String name,
                                         String routingType,
                                         Integer maxConsumers,
                                         Boolean purgeOnNoConsumers,
                                         Boolean exclusive,
                                         String user)
                                  throws Exception

      Deprecated.
      Update a queue
      Parameters:
        `name` - name of the queue
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
        `user` - the user associated with this queue
      Returns:
      Throws:
        `Exception`

    - #### updateQueue

          @Deprecated
          String updateQueue(String name,
                                         String routingType,
                                         String filter,
                                         Integer maxConsumers,
                                         Boolean purgeOnNoConsumers,
                                         Boolean exclusive,
                                         Boolean groupRebalance,
                                         Integer groupBuckets,
                                         Boolean nonDestructive,
                                         Integer consumersBeforeDispatch,
                                         Long delayBeforeDispatch,
                                         String user)
                                  throws Exception

      Deprecated.
      Update a queue
      Parameters:
        `name` - name of the queue
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `filter` - the filter to use on the queue
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
        `groupRebalance` - if the queue should rebalance groups when a consumer is added
        `groupBuckets` - number of buckets that should be used for message groups, -1 (default) is unlimited, and groups by raw key instead
        `nonDestructive` - If the queue is non-destructive
        `consumersBeforeDispatch` - number of consumers needed before dispatch can start
        `delayBeforeDispatch` - delay to wait before dispatching if number of consumers before dispatch is not met
        `user` - the user associated with this queue
      Returns:
      Throws:
        `Exception`

    - #### updateQueue

          @Deprecated
          String updateQueue(String name,
                                         String routingType,
                                         String filter,
                                         Integer maxConsumers,
                                         Boolean purgeOnNoConsumers,
                                         Boolean exclusive,
                                         Boolean groupRebalance,
                                         Integer groupBuckets,
                                         String groupFirstKey,
                                         Boolean nonDestructive,
                                         Integer consumersBeforeDispatch,
                                         Long delayBeforeDispatch,
                                         String user)
                                  throws Exception

      Deprecated.
      Update a queue
      Parameters:
        `name` - name of the queue
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `filter` - the filter to use on the queue
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
        `groupRebalance` - if the queue should rebalance groups when a consumer is added
        `groupBuckets` - number of buckets that should be used for message groups, -1 (default) is unlimited, and groups by raw key instead
        `groupFirstKey` - key used to mark a message is first in a group for a consumer
        `nonDestructive` - If the queue is non-destructive
        `consumersBeforeDispatch` - number of consumers needed before dispatch can start
        `delayBeforeDispatch` - delay to wait before dispatching if number of consumers before dispatch is not met
        `user` - the user associated with this queue
      Returns:
      Throws:
        `Exception`

    - #### updateQueue

          @Deprecated
          String updateQueue(String name,
                                         String routingType,
                                         String filter,
                                         Integer maxConsumers,
                                         Boolean purgeOnNoConsumers,
                                         Boolean exclusive,
                                         Boolean groupRebalance,
                                         Integer groupBuckets,
                                         String groupFirstKey,
                                         Boolean nonDestructive,
                                         Integer consumersBeforeDispatch,
                                         Long delayBeforeDispatch,
                                         String user,
                                         Long ringSize)
                                  throws Exception

      Deprecated.
      Update a queue
      Parameters:
        `name` - name of the queue
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `filter` - the filter to use on the queue
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
        `groupRebalance` - if the queue should rebalance groups when a consumer is added
        `groupBuckets` - number of buckets that should be used for message groups, -1 (default) is unlimited, and groups by raw key instead
        `groupFirstKey` - key used to mark a message is first in a group for a consumer
        `nonDestructive` - If the queue is non-destructive
        `consumersBeforeDispatch` - number of consumers needed before dispatch can start
        `delayBeforeDispatch` - delay to wait before dispatching if number of consumers before dispatch is not met
        `user` - the user associated with this queue
        `ringSize` - the size this queue should maintain according to ring semantics
      Returns:
      Throws:
        `Exception`

    - #### deployQueue

          @Deprecated
          void deployQueue(String address,
                                       String name,
                                       String filter)
                                throws Exception

      Deprecated.
      Deploy a durable queue.
      If `address` is `null` it will be defaulted to `name`.
      This method will do nothing if the queue with the given name already exists on the server.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `filter` - of the queue
      Throws:
        `Exception`

    - #### deployQueue

          @Deprecated
          void deployQueue(String address,
                                       String name,
                                       String filter,
                                       boolean durable)
                                throws Exception

      Deprecated.
      Deploy a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method will do nothing if the queue with the given name already exists on the server.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `filter` - of the queue
        `durable` - whether the queue is durable
      Throws:
        `Exception`

    - #### destroyQueue

          void destroyQueue(String name)
                     throws Exception

      Destroys the queue corresponding to the specified name.
      Throws:
        `Exception`

    - #### destroyQueue

          void destroyQueue(String name,
                            boolean removeConsumers)
                     throws Exception

      Destroys the queue corresponding to the specified name.
      Throws:
        `Exception`

    - #### destroyQueue

          void destroyQueue(String name,
                            boolean removeConsumers,
                            boolean autoDeleteAddress)
                     throws Exception

      Destroys the queue corresponding to the specified name and delete it's address if there are no other queues
      Throws:
        `Exception`

    - #### enableMessageCounters

          void enableMessageCounters()
                              throws Exception

      Enables message counters for this server.
      Throws:
        `Exception`

    - #### disableMessageCounters

          void disableMessageCounters()
                               throws Exception

      Disables message counters for this server.
      Throws:
        `Exception`

    - #### resetAllMessageCounters

          void resetAllMessageCounters()
                                throws Exception

      Reset all message counters.
      Throws:
        `Exception`

    - #### resetAllMessageCounterHistories

          void resetAllMessageCounterHistories()
                                        throws Exception

      Reset histories for all message counters.
      Throws:
        `Exception`

    - #### listPreparedTransactions

          String[] listPreparedTransactions()
                                     throws Exception

      List all the prepared transaction, sorted by date, oldest first.
      The Strings are Base-64 representation of the transaction XID and can be used to heuristically commit or rollback the transactions.
      Throws:
        `Exception`
      See Also:
        `commitPreparedTransaction(String)`, `rollbackPreparedTransaction(String)`

    - #### listPreparedTransactionDetailsAsJSON

          String listPreparedTransactionDetailsAsJSON()
                                               throws Exception

      List all the prepared transaction, sorted by date, oldest first, with details, in text format.
      Throws:
        `Exception`

    - #### listPreparedTransactionDetailsAsHTML

          String listPreparedTransactionDetailsAsHTML()
                                               throws Exception

      List all the prepared transaction, sorted by date, oldest first, with details, in HTML format
      Throws:
        `Exception`

    - #### listHeuristicCommittedTransactions

          String[] listHeuristicCommittedTransactions()
                                               throws Exception

      List transactions which have been heuristically committed.
      Throws:
        `Exception`

    - #### listHeuristicRolledBackTransactions

          String[] listHeuristicRolledBackTransactions()
                                                throws Exception

      List transactions which have been heuristically rolled back.
      Throws:
        `Exception`

    - #### commitPreparedTransaction

          boolean commitPreparedTransaction(String transactionAsBase64)
                                     throws Exception

      Heuristically commits a prepared transaction.
      Parameters:
        `transactionAsBase64` - base 64 representation of a prepare transaction
      Returns:
        `true` if the transaction was successfully committed, `false` else
      Throws:
        `Exception`
      See Also:
        `listPreparedTransactions()`

    - #### rollbackPreparedTransaction

          boolean rollbackPreparedTransaction(String transactionAsBase64)
                                       throws Exception

      Heuristically rolls back a prepared transaction.
      Parameters:
        `transactionAsBase64` - base 64 representation of a prepare transaction
      Returns:
        `true` if the transaction was successfully rolled back, `false` else
      Throws:
        `Exception`
      See Also:
        `listPreparedTransactions()`

    - #### listRemoteAddresses

          String[] listRemoteAddresses()
                                throws Exception

      Lists the addresses of all the clients connected to this address.
      Throws:
        `Exception`

    - #### listRemoteAddresses

          String[] listRemoteAddresses(String ipAddress)
                                throws Exception

      Lists the addresses of the clients connected to this address which matches the specified IP address.
      Throws:
        `Exception`

    - #### closeConnectionsForAddress

          boolean closeConnectionsForAddress(String ipAddress)
                                      throws Exception

      Closes all the connections of clients connected to this server which matches the specified IP address.
      Throws:
        `Exception`

    - #### closeConsumerConnectionsForAddress

          boolean closeConsumerConnectionsForAddress(String address)
                                              throws Exception

      Closes all the connections of clients connected to this server which matches the specified IP address.
      Throws:
        `Exception`

    - #### closeConnectionsForUser

          boolean closeConnectionsForUser(String address)
                                   throws Exception

      Closes all the connections of sessions with a matching user name.
      Throws:
        `Exception`

    - #### closeConnectionWithID

          boolean closeConnectionWithID(String ID)
                                 throws Exception

      Closes the connection with the given id.
      Throws:
        `Exception`

    - #### closeSessionWithID

          boolean closeSessionWithID(String connectionID,
                                     String ID)
                              throws Exception

      Closes the session with the given id.
      Throws:
        `Exception`

    - #### closeConsumerWithID

          boolean closeConsumerWithID(String sessionID,
                                      String ID)
                               throws Exception

      Closes the consumer with the given id.
      Throws:
        `Exception`

    - #### listConnectionIDs

          String[] listConnectionIDs()
                              throws Exception

      Lists all the IDs of the connections connected to this server.
      Throws:
        `Exception`

    - #### listProducersInfoAsJSON

          String listProducersInfoAsJSON()
                                  throws Exception

      Throws:
        `Exception`

    - #### listConnectionsAsJSON

          String listConnectionsAsJSON()
                                throws Exception

      Lists all the connections connected to this server. The returned String is a JSON string containing details about each connection, e.g.:

           [
             {
               "creationTime": 1469240429671,
               "sessionCount": 1,
               "implementation": "RemotingConnectionImpl",
               "connectionID": "1648309901",
               "clientAddress": "\/127.0.0.1:57649"
             }
           ]

      Throws:
        `Exception`

    - #### listConsumersAsJSON

          String listConsumersAsJSON(String connectionID)
                              throws Exception

      Lists all the consumers which belongs to the connection specified by the connectionID. The returned String is a JSON string containing details about each consumer, e.g.:

           [
             {
               "filter": "color = 'RED'",
               "queueName": "2ea5b050-28bf-4ee2-9b24-b73f5983192a",
               "creationTime": 1469239602459,
               "deliveringCount": 0,
               "consumerID": 1,
               "browseOnly": true,
               "connectionID": "1963ece3-507a-11e6-94ff-e8b1fc439540",
               "sessionID": "19676f55-507a-11e6-94ff-e8b1fc439540"
             }
           ]

      Throws:
        `Exception`

    - #### listAllConsumersAsJSON

          String listAllConsumersAsJSON()
                                 throws Exception

      Lists all the consumers connected to this server. The returned String is a JSON string containing details about each consumer, e.g.:

           [
             {
               "queueName": "fa87c64c-0a38-4697-8421-72e34d17429d",
               "creationTime": 1469235956168,
               "deliveringCount": 0,
               "consumerID": 0,
               "browseOnly": false,
               "connectionID": "9c0d42e7-5071-11e6-9e29-e8b1fc439540",
               "sessionID": "9c0d9109-5071-11e6-9e29-e8b1fc439540"
             }
           ]

      Throws:
        `Exception`

    - #### listSessionsAsJSON

          String listSessionsAsJSON(String connectionID)
                             throws Exception

      Lists details about all the sessions for the specified connection ID. The returned String is a JSON string containing details about each session associated with the specified ID, e.g.:

           [
             {
               "principal": "myUser",
               "creationTime": 1469240773157,
               "consumerCount": 0,
               "sessionID": "d33d10db-507c-11e6-9e47-e8b1fc439540"
             }
           ]

      Throws:
        `Exception`

    - #### listAllSessionsAsJSON

          String listAllSessionsAsJSON()
                                throws Exception

      Lists details about all sessions. The returned String is a JSON string containing details about each and every session, e.g.:

           [
             {
               "sessionID":"e71d61d7-2176-11e8-9057-a0afbd82eaba",
               "creationTime":1520365520212,
               "consumerCount":1,
               "principal":"myUser"
             },
             {
               "sessionID":"e718a6e6-2176-11e8-9057-a0afbd82eaba",
               "creationTime":1520365520191,
               "consumerCount":0,
               "principal":"guest"
             }
           ]

      Throws:
        `Exception`

    - #### listSessions

          String[] listSessions(String connectionID)
                         throws Exception

      Lists all the sessions IDs for the specified connection ID.
      Throws:
        `Exception`

    - #### addSecuritySettings

          void addSecuritySettings(String addressMatch,
                                   String sendRoles,
                                   String consumeRoles,
                                   String createDurableQueueRoles,
                                   String deleteDurableQueueRoles,
                                   String createNonDurableQueueRoles,
                                   String deleteNonDurableQueueRoles,
                                   String manageRoles)
                            throws Exception

      Throws:
        `Exception`

    - #### addSecuritySettings

          void addSecuritySettings(String addressMatch,
                                   String sendRoles,
                                   String consumeRoles,
                                   String createDurableQueueRoles,
                                   String deleteDurableQueueRoles,
                                   String createNonDurableQueueRoles,
                                   String deleteNonDurableQueueRoles,
                                   String manageRoles,
                                   String browseRoles)
                            throws Exception

      Throws:
        `Exception`

    - #### addSecuritySettings

          void addSecuritySettings(String addressMatch,
                                   String sendRoles,
                                   String consumeRoles,
                                   String createDurableQueueRoles,
                                   String deleteDurableQueueRoles,
                                   String createNonDurableQueueRoles,
                                   String deleteNonDurableQueueRoles,
                                   String manageRoles,
                                   String browseRoles,
                                   String createAddressRoles,
                                   String deleteAddressRoles)
                            throws Exception

      Throws:
        `Exception`

    - #### removeSecuritySettings

          void removeSecuritySettings(String addressMatch)
                               throws Exception

      Throws:
        `Exception`

    - #### getRoles

          Object[] getRoles(String addressMatch)
                     throws Exception

      Throws:
        `Exception`

    - #### getRolesAsJSON

          String getRolesAsJSON(String addressMatch)
                         throws Exception

      Throws:
        `Exception`

    - #### addAddressSettings

          void addAddressSettings(String addressMatch,
                                  String DLA,
                                  String expiryAddress,
                                  long expiryDelay,
                                  boolean lastValueQueue,
                                  int deliveryAttempts,
                                  long maxSizeBytes,
                                  int pageSizeBytes,
                                  int pageMaxCacheSize,
                                  long redeliveryDelay,
                                  double redeliveryMultiplier,
                                  long maxRedeliveryDelay,
                                  long redistributionDelay,
                                  boolean sendToDLAOnNoRoute,
                                  String addressFullMessagePolicy,
                                  long slowConsumerThreshold,
                                  long slowConsumerCheckPeriod,
                                  String slowConsumerPolicy,
                                  boolean autoCreateJmsQueues,
                                  boolean autoDeleteJmsQueues,
                                  boolean autoCreateJmsTopics,
                                  boolean autoDeleteJmsTopics)
                           throws Exception

      adds a new address setting for a specific address
      Throws:
        `Exception`

    - #### addAddressSettings

          void addAddressSettings(String addressMatch,
                                  String DLA,
                                  String expiryAddress,
                                  long expiryDelay,
                                  boolean lastValueQueue,
                                  int deliveryAttempts,
                                  long maxSizeBytes,
                                  int pageSizeBytes,
                                  int pageMaxCacheSize,
                                  long redeliveryDelay,
                                  double redeliveryMultiplier,
                                  long maxRedeliveryDelay,
                                  long redistributionDelay,
                                  boolean sendToDLAOnNoRoute,
                                  String addressFullMessagePolicy,
                                  long slowConsumerThreshold,
                                  long slowConsumerCheckPeriod,
                                  String slowConsumerPolicy,
                                  boolean autoCreateJmsQueues,
                                  boolean autoDeleteJmsQueues,
                                  boolean autoCreateJmsTopics,
                                  boolean autoDeleteJmsTopics,
                                  boolean autoCreateQueues,
                                  boolean autoDeleteQueues,
                                  boolean autoCreateAddresses,
                                  boolean autoDeleteAddresses)
                           throws Exception

      adds a new address setting for a specific address
      Throws:
        `Exception`

    - #### addAddressSettings

          void addAddressSettings(String addressMatch,
                                  String DLA,
                                  String expiryAddress,
                                  long expiryDelay,
                                  boolean lastValueQueue,
                                  int deliveryAttempts,
                                  long maxSizeBytes,
                                  int pageSizeBytes,
                                  int pageMaxCacheSize,
                                  long redeliveryDelay,
                                  double redeliveryMultiplier,
                                  long maxRedeliveryDelay,
                                  long redistributionDelay,
                                  boolean sendToDLAOnNoRoute,
                                  String addressFullMessagePolicy,
                                  long slowConsumerThreshold,
                                  long slowConsumerCheckPeriod,
                                  String slowConsumerPolicy,
                                  boolean autoCreateJmsQueues,
                                  boolean autoDeleteJmsQueues,
                                  boolean autoCreateJmsTopics,
                                  boolean autoDeleteJmsTopics,
                                  boolean autoCreateQueues,
                                  boolean autoDeleteQueues,
                                  boolean autoCreateAddresses,
                                  boolean autoDeleteAddresses,
                                  String configDeleteQueues,
                                  String configDeleteAddresses,
                                  long maxSizeBytesRejectThreshold,
                                  String defaultLastValueKey,
                                  boolean defaultNonDestructive,
                                  boolean defaultExclusiveQueue,
                                  boolean defaultGroupRebalance,
                                  int defaultGroupBuckets,
                                  String defaultGroupFirstKey,
                                  int defaultMaxConsumers,
                                  boolean defaultPurgeOnNoConsumers,
                                  int defaultConsumersBeforeDispatch,
                                  long defaultDelayBeforeDispatch,
                                  String defaultQueueRoutingType,
                                  String defaultAddressRoutingType,
                                  int defaultConsumerWindowSize,
                                  long defaultRingSize,
                                  boolean autoDeleteCreatedQueues,
                                  long autoDeleteQueuesDelay,
                                  long autoDeleteQueuesMessageCount,
                                  long autoDeleteAddressesDelay,
                                  double redeliveryCollisionAvoidanceFactor,
                                  long retroactiveMessageCount)
                           throws Exception

      adds a new address setting for a specific address
      Throws:
        `Exception`

    - #### addAddressSettings

          void addAddressSettings(String addressMatch,
                                  String DLA,
                                  String expiryAddress,
                                  long expiryDelay,
                                  boolean lastValueQueue,
                                  int deliveryAttempts,
                                  long maxSizeBytes,
                                  int pageSizeBytes,
                                  int pageMaxCacheSize,
                                  long redeliveryDelay,
                                  double redeliveryMultiplier,
                                  long maxRedeliveryDelay,
                                  long redistributionDelay,
                                  boolean sendToDLAOnNoRoute,
                                  String addressFullMessagePolicy,
                                  long slowConsumerThreshold,
                                  long slowConsumerCheckPeriod,
                                  String slowConsumerPolicy,
                                  boolean autoCreateJmsQueues,
                                  boolean autoDeleteJmsQueues,
                                  boolean autoCreateJmsTopics,
                                  boolean autoDeleteJmsTopics,
                                  boolean autoCreateQueues,
                                  boolean autoDeleteQueues,
                                  boolean autoCreateAddresses,
                                  boolean autoDeleteAddresses,
                                  String configDeleteQueues,
                                  String configDeleteAddresses,
                                  long maxSizeBytesRejectThreshold,
                                  String defaultLastValueKey,
                                  boolean defaultNonDestructive,
                                  boolean defaultExclusiveQueue,
                                  boolean defaultGroupRebalance,
                                  int defaultGroupBuckets,
                                  String defaultGroupFirstKey,
                                  int defaultMaxConsumers,
                                  boolean defaultPurgeOnNoConsumers,
                                  int defaultConsumersBeforeDispatch,
                                  long defaultDelayBeforeDispatch,
                                  String defaultQueueRoutingType,
                                  String defaultAddressRoutingType,
                                  int defaultConsumerWindowSize,
                                  long defaultRingSize,
                                  boolean autoDeleteCreatedQueues,
                                  long autoDeleteQueuesDelay,
                                  long autoDeleteQueuesMessageCount,
                                  long autoDeleteAddressesDelay,
                                  double redeliveryCollisionAvoidanceFactor,
                                  long retroactiveMessageCount,
                                  boolean autoCreateDeadLetterResources,
                                  String deadLetterQueuePrefix,
                                  String deadLetterQueueSuffix,
                                  boolean autoCreateExpiryResources,
                                  String expiryQueuePrefix,
                                  String expiryQueueSuffix)
                           throws Exception

      adds a new address setting for a specific address
      Throws:
        `Exception`

    - #### removeAddressSettings

          void removeAddressSettings(String addressMatch)
                              throws Exception

      Throws:
        `Exception`

    - #### getAddressSettingsAsJSON

          String getAddressSettingsAsJSON(String addressMatch)
                                   throws Exception

      returns the address settings as a JSON string
      Throws:
        `Exception`

    - #### getDivertNames

          String[] getDivertNames()

    - #### listDivertNames

          default String[] listDivertNames()

      Jon plugin doesn't recognize an Operation whose name is in form getXXXX(), so add this one.

    - #### createDivert

          void createDivert(String name,
                            String routingName,
                            String address,
                            String forwardingAddress,
                            boolean exclusive,
                            String filterString,
                            String transformerClassName)
                     throws Exception

      Throws:
        `Exception`

    - #### createDivert

          void createDivert(String name,
                            String routingName,
                            String address,
                            String forwardingAddress,
                            boolean exclusive,
                            String filterString,
                            String transformerClassName,
                            String routingType)
                     throws Exception

      Throws:
        `Exception`

    - #### createDivert

          void createDivert(String name,
                            String routingName,
                            String address,
                            String forwardingAddress,
                            boolean exclusive,
                            String filterString,
                            String transformerClassName,
                            Map<String,String> transformerProperties,
                            String routingType)
                     throws Exception

      Throws:
        `Exception`

    - #### createDivert

          void createDivert(String name,
                            String routingName,
                            String address,
                            String forwardingAddress,
                            boolean exclusive,
                            String filterString,
                            String transformerClassName,
                            String transformerPropertiesAsJSON,
                            String routingType)
                     throws Exception

      Throws:
        `Exception`

    - #### destroyDivert

          void destroyDivert(String name)
                      throws Exception

      Throws:
        `Exception`

    - #### getBridgeNames

          String[] getBridgeNames()

    - #### createBridge

          void createBridge(String name,
                            String queueName,
                            String forwardingAddress,
                            String filterString,
                            String transformerClassName,
                            long retryInterval,
                            double retryIntervalMultiplier,
                            int initialConnectAttempts,
                            int reconnectAttempts,
                            boolean useDuplicateDetection,
                            int confirmationWindowSize,
                            int producerWindowSize,
                            long clientFailureCheckPeriod,
                            String connectorNames,
                            boolean useDiscoveryGroup,
                            boolean ha,
                            String user,
                            String password)
                     throws Exception

      Throws:
        `Exception`

    - #### createBridge

          void createBridge(String name,
                            String queueName,
                            String forwardingAddress,
                            String filterString,
                            String transformerClassName,
                            Map<String,String> transformerProperties,
                            long retryInterval,
                            double retryIntervalMultiplier,
                            int initialConnectAttempts,
                            int reconnectAttempts,
                            boolean useDuplicateDetection,
                            int confirmationWindowSize,
                            int producerWindowSize,
                            long clientFailureCheckPeriod,
                            String connectorNames,
                            boolean useDiscoveryGroup,
                            boolean ha,
                            String user,
                            String password)
                     throws Exception

      Throws:
        `Exception`

    - #### createBridge

          void createBridge(String name,
                            String queueName,
                            String forwardingAddress,
                            String filterString,
                            String transformerClassName,
                            String transformerPropertiesAsJSON,
                            long retryInterval,
                            double retryIntervalMultiplier,
                            int initialConnectAttempts,
                            int reconnectAttempts,
                            boolean useDuplicateDetection,
                            int confirmationWindowSize,
                            int producerWindowSize,
                            long clientFailureCheckPeriod,
                            String connectorNames,
                            boolean useDiscoveryGroup,
                            boolean ha,
                            String user,
                            String password)
                     throws Exception

      Throws:
        `Exception`

    - #### createBridge

          void createBridge(String name,
                            String queueName,
                            String forwardingAddress,
                            String filterString,
                            String transformerClassName,
                            long retryInterval,
                            double retryIntervalMultiplier,
                            int initialConnectAttempts,
                            int reconnectAttempts,
                            boolean useDuplicateDetection,
                            int confirmationWindowSize,
                            long clientFailureCheckPeriod,
                            String connectorNames,
                            boolean useDiscoveryGroup,
                            boolean ha,
                            String user,
                            String password)
                     throws Exception

      Throws:
        `Exception`

    - #### destroyBridge

          void destroyBridge(String name)
                      throws Exception

      Throws:
        `Exception`

    - #### createConnectorService

          void createConnectorService(String name,
                                      String factoryClass,
                                      Map<String,Object> parameters)
                               throws Exception

      Throws:
        `Exception`

    - #### destroyConnectorService

          void destroyConnectorService(String name)
                                throws Exception

      Throws:
        `Exception`

    - #### getConnectorServices

          String[] getConnectorServices()

    - #### forceFailover

          void forceFailover()
                      throws Exception

      Throws:
        `Exception`

    - #### scaleDown

          void scaleDown(String connector)
                  throws Exception

      Throws:
        `Exception`

    - #### listNetworkTopology

          String listNetworkTopology()
                              throws Exception

      Throws:
        `Exception`

    - #### getAddressInfo

          String getAddressInfo(String address)
                         throws ActiveMQAddressDoesNotExistException

      Throws:
        `ActiveMQAddressDoesNotExistException`

    - #### listBindingsForAddress

          String listBindingsForAddress(String address)
                                 throws Exception

      Throws:
        `Exception`

    - #### listAddresses

          String listAddresses(String separator)
                        throws Exception

      Throws:
        `Exception`

    - #### listConnections

          String listConnections(String options,
                                 int page,
                                 int pageSize)
                          throws Exception

      Throws:
        `Exception`

    - #### listSessions

          String listSessions(String options,
                              int page,
                              int pageSize)
                       throws Exception

      Throws:
        `Exception`

    - #### listConsumers

          String listConsumers(String options,
                               int page,
                               int pageSize)
                        throws Exception

      Throws:
        `Exception`

    - #### listProducers

          String listProducers(String options,
                               int page,
                               int pageSize)
                        throws Exception

      Throws:
        `Exception`

    - #### listAddresses

          String listAddresses(String options,
                               int page,
                               int pageSize)
                        throws Exception

      Throws:
        `Exception`

    - #### listQueues

          String listQueues(String options,
                            int page,
                            int pageSize)
                     throws Exception

      Throws:
        `Exception`

    - #### getQueueNames

          String[] getQueueNames(String routingType)

      Returns the names of the queues created on this server with the given routing-type.

    - #### getClusterConnectionNames

          String[] getClusterConnectionNames()

      Returns the names of the cluster-connections deployed on this server.

    - #### addUser

          void addUser(String username,
                       String password,
                       String roles,
                       boolean plaintext)
                throws Exception

      Add a user (only applicable when using the JAAS PropertiesLoginModule)
      Parameters:
        `username` -
        `password` -
        `roles` -
      Throws:
        `Exception`

    - #### listUser

          String listUser(String username)
                   throws Exception

      List the information about a user or all users if no username is supplied (only applicable when using the JAAS PropertiesLoginModule).
      Parameters:
        `username` -
      Returns:
        JSON array of user & role information
      Throws:
        `Exception`

    - #### removeUser

          void removeUser(String username)
                   throws Exception

      Remove a user (only applicable when using the JAAS PropertiesLoginModule).
      Parameters:
        `username` -
      Throws:
        `Exception`

    - #### resetUser

          void resetUser(String username,
                         String password,
                         String roles)
                  throws Exception

      Set new properties on an existing user (only applicable when using the JAAS PropertiesLoginModule).
      Parameters:
        `username` -
        `password` -
        `roles` -
      Throws:
        `Exception`

    - #### resetUser

          void resetUser(String username,
                         String password,
                         String roles,
                         boolean plaintext)
                  throws Exception

      Set new properties on an existing user (only applicable when using the JAAS PropertiesLoginModule).
      Parameters:
        `username` -
        `password` -
        `roles` -
        `plaintext` -
      Throws:
        `Exception`

Copyright © 2020 The Apache Software Foundation. All rights reserved.